package com.ruoyi.system.utils;

import com.ruoyi.common.core.utils.StringUtils;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class AesUtils {
   public static String encrypt(String plaintext) {
      if (StringUtils.isEmpty(plaintext)) {
         return null;
      } else if (plaintext.endsWith("@gn")) {
         return plaintext;
      } else {
         byte[] iv = generateIVFixation();
         SecretKeySpec keySpec = generateKey();
         byte[] cipherText = encrypt(plaintext, keySpec, iv);
         return cipherText == null ? null : bytesToHex(cipherText) + "@gn";
      }
   }

   public static String decrypt(String cipherText) {
      if (!StringUtils.isEmpty(cipherText) && cipherText.endsWith("@gn")) {
         byte[] iv = generateIVFixation();
         SecretKeySpec keySpec = generateKey();
         return decrypt(hexStringToByteArray(cipherText.replace("@gn", "")), keySpec, iv);
      } else {
         return cipherText;
      }
   }

   public static SecretKeySpec generateKey() {
      byte[] keyBytes = hexStringToByteArray("888762A983741DBC8D05B34EF501A7E8");
      return new SecretKeySpec(keyBytes, "AES");
   }

   public static byte[] generateIVFixation() {
      byte[] fixedIV = hexStringToByteArray("0DE102F8524666EDB3628FF31F11B465");
      return fixedIV;
   }

   public static byte[] encrypt(String plaintext, SecretKey key, byte[] iv) {
      try {
         Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
         IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
         cipher.init(1, key, ivParameterSpec);
         byte[] cipherText = cipher.doFinal(plaintext.getBytes());
         return cipherText;
      } catch (Exception var6) {
         return null;
      }
   }

   public static String decrypt(byte[] cipherText, SecretKey key, byte[] iv) {
      try {
         Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
         IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
         cipher.init(2, key, ivParameterSpec);
         byte[] plainText = cipher.doFinal(cipherText);
         return new String(plainText);
      } catch (Exception var6) {
         return null;
      }
   }

   public static byte[] hexStringToByteArray(String s) {
      int len = s.length();
      byte[] data = new byte[len / 2];

      for(int i = 0; i < len; i += 2) {
         data[i / 2] = (byte)((Character.digit(s.charAt(i), 16) << 4) + Character.digit(s.charAt(i + 1), 16));
      }

      return data;
   }

   public static byte[] generateIV() throws NoSuchAlgorithmException {
      SecureRandom random = SecureRandom.getInstanceStrong();
      byte[] iv = new byte[16];
      random.nextBytes(iv);
      return iv;
   }

   public static String bytesToHex(byte[] bytes) {
      StringBuilder result = new StringBuilder();
      byte[] var2 = bytes;
      int var3 = bytes.length;

      for(int var4 = 0; var4 < var3; ++var4) {
         byte b = var2[var4];
         result.append(String.format("%02X", b));
      }

      return result.toString();
   }

   public static String getData(String val, String symbol, int subscript) {
      String[] vals = val.split(symbol);
      return vals[subscript];
   }

   public static void main(String[] args) {
      System.out.println("解密: " + decrypt("29F9A9898587BEFC29D9B6CB0A3D5C50779352CC005864D81CE19CBA12EC1590@gn"));
   }
}
